import board
import digitalio
import simple_wifi
import simple_mqtt
import supervisor
import time
from thingz import button_a
from thingz import button_b

simpleWifi = simple_wifi.SimpleWifi()
galaxiaChronometer = time.monotonic_ns()

def display_clear():
    print('[2J', end='')

def configure_pin(pin, pinNumber, type):
    if type == "digital_write":
        if len(pin) and isinstance(pin, digitalio.DigitalInOut):
            pin[0].direction = digitalio.Direction.OUTPUT
        else:
            if len(pin):
                pin[0].deinit()
                pin[0] = digitalio.DigitalInOut(pinNumber)
                pin[0].direction = digitalio.Direction.OUTPUT
            else:
                pin.append(digitalio.DigitalInOut(pinNumber))
                pin[0].direction = digitalio.Direction.OUTPUT
    elif type == "digital_read":
        if len(pin) and isinstance(pin, digitalio.DigitalInOut):
            pin[0].direction = digitalio.Direction.INPUT
        else:
            if len(pin):
                pin[0].deinit()
                pin[0] = digitalio.DigitalInOut(pinNumber)
                pin[0].direction = digitalio.Direction.INPUT
            else:
                pin.append(digitalio.DigitalInOut(pinNumber))
                pin[0].direction = digitalio.Direction.INPUT
    elif type == "analog_read":
        if len(pin) == 0 or not isinstance(pin, analogio.AnalogIn):
            if len(pin):
                pin[0].deinit()
                pin[0] = analogio.AnalogIn(pinNumber)
            else:
                pin.append(analogio.AnalogIn(pinNumber))
    return pin

def digital_write(pin, pinNumber, state):
    pin = configure_pin(pin, pinNumber, "digital_write")
    pin[0].value = state

def simple_mqtt_on_disconnected():
    pass

def simple_mqtt_on_connected():
    pass

def simple_mqtt_on_message(topic, message):
    pass

def digital_read(pin, pinNumber):
    pin = configure_pin(pin, pinNumber, "digital_read")
    return pin[0].value

def on_pressed_a(button):
    digital_write(pin19, board.P19, True)
    print('Tapis en marche...')

def on_pressed_b(button):
    digital_write(pin19, board.P19, False)
    print('Tapis arrêté')

pin19 = []
simpleMqtt = simple_mqtt.SimpleMQTT('a', 'a', '192.168.1.29', 1883, simple_wifi._simple_tcp_socket_pool, simple_mqtt_on_connected, simple_mqtt_on_disconnected, simple_mqtt_on_message)
simpleMqttCb = lambda: simpleMqtt.process()
try:
    supervisor.add_background_user_callback(simpleMqttCb, period=300)
except TypeError:
    supervisor.add_background_user_callback(simpleMqttCb)

pin7 = []
button_a.on_button_pressed(on_pressed_a)
button_b.on_button_pressed(on_pressed_b)

display_clear()
print('TP n°7 MSPC')
print('Contrôle bourrage MQTT')
print('Tapis sur P19')
print('Capteur bouteille sur P7')
print('Appuyer sur A avancer')
print('Appuyer sur B arrêter')
digital_write(pin19, board.P19, False)
simpleWifi.connect('SFR_B5F8', '45cdmi6ygm24wdrd5nxa')
simpleMqtt.connect()

while True:
    if not digital_read(pin7, board.P7):
        galaxiaChronometer = time.monotonic_ns()
        while not digital_read(pin7, board.P7) and int((time.monotonic_ns() - galaxiaChronometer)/1000000000) <= 2:
            pass
        if not digital_read(pin7, board.P7) and int((time.monotonic_ns() - galaxiaChronometer)/1000000000) >= 2:
            simpleMqtt.publish('bouteille/bourrage', 'Bourrage')
            print('Bourrage!')
        else:
            simpleMqtt.publish('bouteille/bourrage', 'Bouteille OK...')
            print('Bouteille ok pas bourrage')
