import simple_wifi
import simple_mqtt
import supervisor
import board
import digitalio
import time

simpleWifi = simple_wifi.SimpleWifi()
galaxiaChronometer = time.monotonic_ns()

def display_clear():
    print('[2J', end='')

def simple_mqtt_on_disconnected():
    pass

def simple_mqtt_on_connected():
    pass

def simple_mqtt_on_message(topic,message):
    if topic == 'bouteille/tapis':
        if message == '1':
            digital_write(pin19, board.P19, True)
            print('Tapis en marche...')
        else:
            if message == '0':
                digital_write(pin19, board.P19, False)
                print('Tapis arrêté')

def configure_pin(pin, pinNumber, type):
    if type == "digital_write":
        if len(pin) and isinstance(pin, digitalio.DigitalInOut):
            pin[0].direction = digitalio.Direction.OUTPUT
        else:
            if len(pin):
                pin[0].deinit()
                pin[0] = digitalio.DigitalInOut(pinNumber)
                pin[0].direction = digitalio.Direction.OUTPUT
            else:
                pin.append(digitalio.DigitalInOut(pinNumber))
                pin[0].direction = digitalio.Direction.OUTPUT
    elif type == "digital_read":
        if len(pin) and isinstance(pin, digitalio.DigitalInOut):
            pin[0].direction = digitalio.Direction.INPUT
        else:
            if len(pin):
                pin[0].deinit()
                pin[0] = digitalio.DigitalInOut(pinNumber)
                pin[0].direction = digitalio.Direction.INPUT
            else:
                pin.append(digitalio.DigitalInOut(pinNumber))
                pin[0].direction = digitalio.Direction.INPUT
    elif type == "analog_read":
        if len(pin) == 0 or not isinstance(pin, analogio.AnalogIn):
            if len(pin):
                pin[0].deinit()
                pin[0] = analogio.AnalogIn(pinNumber)
            else:
                pin.append(analogio.AnalogIn(pinNumber))
    return pin

def digital_write(pin, pinNumber, state):
    pin = configure_pin(pin, pinNumber, "digital_write")
    pin[0].value = state

def digital_read(pin, pinNumber):
    pin = configure_pin(pin, pinNumber, "digital_read")
    return pin[0].value

simpleMqtt = simple_mqtt.SimpleMQTT('a', 'a', '192.168.1.29', 1883, simple_wifi._simple_tcp_socket_pool, simple_mqtt_on_connected, simple_mqtt_on_disconnected, simple_mqtt_on_message)
simpleMqttCb = lambda: simpleMqtt.process()
try:
    supervisor.add_background_user_callback(simpleMqttCb, period=300)
except TypeError:
    supervisor.add_background_user_callback(simpleMqttCb)

pin19 = []
pin7 = []

display_clear()
print('TP n°7 MSPC')
print('Contrôle bourrage MQTT')
print('Contrôle tapis MQTT')
print('Tapis connecté sur P19')
print('Capteur bourrage sur P7')
simpleWifi.connect('SFR_B5F8', '45cdmi6ygm24wdrd5nxa')
simpleMqtt.connect()
simpleMqtt.subscribe('bouteille/tapis')
digital_write(pin19, board.P19, False)

while True:
    if not digital_read(pin7, board.P7):
        galaxiaChronometer = time.monotonic_ns()
        while not digital_read(pin7, board.P7) and int((time.monotonic_ns() - galaxiaChronometer)/1000000000) <= 2:
            pass
        if not digital_read(pin7, board.P7) and int((time.monotonic_ns() - galaxiaChronometer)/1000000000) >= 2:
            simpleMqtt.publish('bouteille/bourrage', 'Bourrage')
            print('Bourrage!')
        else:
            simpleMqtt.publish('bouteille/bourrage', 'Bouteille OK...')
            print('Bouteille ok pas bourrage')
