import board
import digitalio
from thingz import button_a
from thingz import button_b

def display_clear():
    print('[2J', end='')

def configure_pin(pin, pinNumber, type):
    if type == "digital_write":
        if len(pin) and isinstance(pin, digitalio.DigitalInOut):
            pin[0].direction = digitalio.Direction.OUTPUT
        else:
            if len(pin):
                pin[0].deinit()
                pin[0] = digitalio.DigitalInOut(pinNumber)
                pin[0].direction = digitalio.Direction.OUTPUT
            else:
                pin.append(digitalio.DigitalInOut(pinNumber))
                pin[0].direction = digitalio.Direction.OUTPUT
    elif type == "digital_read":
        if len(pin) and isinstance(pin, digitalio.DigitalInOut):
            pin[0].direction = digitalio.Direction.INPUT
        else:
            if len(pin):
                pin[0].deinit()
                pin[0] = digitalio.DigitalInOut(pinNumber)
                pin[0].direction = digitalio.Direction.INPUT
            else:
                pin.append(digitalio.DigitalInOut(pinNumber))
                pin[0].direction = digitalio.Direction.INPUT
    elif type == "analog_read":
        if len(pin) == 0 or not isinstance(pin, analogio.AnalogIn):
            if len(pin):
                pin[0].deinit()
                pin[0] = analogio.AnalogIn(pinNumber)
            else:
                pin.append(analogio.AnalogIn(pinNumber))
    return pin

def digital_write(pin, pinNumber, state):
    pin = configure_pin(pin, pinNumber, "digital_write")
    pin[0].value = state

def on_pressed_a(button):
    global bouton_B, bouton_A
    bouton_B = False
    if not bouton_A:
        digital_write(pin19, board.P19, True)
        print('Tapis avance...')
    bouton_A = True

def on_pressed_b(button):
    global bouton_B, bouton_A
    bouton_A = False
    if not bouton_B:
        digital_write(pin19, board.P19, False)
        print('Tapis arrêter...')
    bouton_B = True

pin19 = []
button_a.on_button_pressed(on_pressed_a)
button_b.on_button_pressed(on_pressed_b)

display_clear()
print('MSPC tp7')
print('Test commande manuelle')
print('Tapis roulant')
print('Relais sur Grove 1 (P19)')
print('Appuyez sur A démarrage')
print('Appuyez sur B arrêt')
digital_write(pin19, board.P19, False)
bouton_A = False
bouton_B = False

while True:
    pass
