import board
import digitalio
from thingz import button_a
import time
import math

galaxiaChronometer = time.monotonic_ns()

def display_clear():
    print('[2J', end='')

def configure_pin(pin, pinNumber, type):
    if type == "digital_write":
        if len(pin) and isinstance(pin, digitalio.DigitalInOut):
            pin[0].direction = digitalio.Direction.OUTPUT
        else:
            if len(pin):
                pin[0].deinit()
                pin[0] = digitalio.DigitalInOut(pinNumber)
                pin[0].direction = digitalio.Direction.OUTPUT
            else:
                pin.append(digitalio.DigitalInOut(pinNumber))
                pin[0].direction = digitalio.Direction.OUTPUT
    elif type == "digital_read":
        if len(pin) and isinstance(pin, digitalio.DigitalInOut):
            pin[0].direction = digitalio.Direction.INPUT
        else:
            if len(pin):
                pin[0].deinit()
                pin[0] = digitalio.DigitalInOut(pinNumber)
                pin[0].direction = digitalio.Direction.INPUT
            else:
                pin.append(digitalio.DigitalInOut(pinNumber))
                pin[0].direction = digitalio.Direction.INPUT
    elif type == "analog_read":
        if len(pin) == 0 or not isinstance(pin, analogio.AnalogIn):
            if len(pin):
                pin[0].deinit()
                pin[0] = analogio.AnalogIn(pinNumber)
            else:
                pin.append(analogio.AnalogIn(pinNumber))
    return pin

def digital_write(pin, pinNumber, state):
    pin = configure_pin(pin, pinNumber, "digital_write")
    pin[0].value = state

def digital_read(pin, pinNumber):
    pin = configure_pin(pin, pinNumber, "digital_read")
    return pin[0].value

pin1 = []
pin19 = []
pin7 = []

display_clear()
print('TP n°7 MSPC')
print('Mesure vitesse tapis')
print('Distance capteurs=41cm')
print('Capt départ Grove 1 P19')
print('Capt arrivée Grove 2 P7')
print('Relais sur P1')
print('Appuyer touche A')
digital_write(pin1, board.P1, False)

while True:
    while not button_a.was_pressed():
        pass
    print('Démarrage tapis...')
    digital_write(pin1, board.P1, True)
    while digital_read(pin19, board.P19):
        pass
    galaxiaChronometer = time.monotonic_ns()
    print('détection départ bouteille')
    while digital_read(pin7, board.P7):
        pass
    print(''.join([str(x) for x in ['Vitesse tapis=', round(41000 / int((time.monotonic_ns() - galaxiaChronometer)/1000000)), 'cm/s']]))
    digital_write(pin1, board.P1, False)
