import board
import digitalio
import time
from thingz import button_a
from thingz import button_b

def display_clear():
    print('[2J', end='')

def configure_pin(pin, pinNumber, type):
    if type == "digital_write":
        if len(pin) and isinstance(pin, digitalio.DigitalInOut):
            pin[0].direction = digitalio.Direction.OUTPUT
        else:
            if len(pin):
                pin[0].deinit()
                pin[0] = digitalio.DigitalInOut(pinNumber)
                pin[0].direction = digitalio.Direction.OUTPUT
            else:
                pin.append(digitalio.DigitalInOut(pinNumber))
                pin[0].direction = digitalio.Direction.OUTPUT
    elif type == "digital_read":
        if len(pin) and isinstance(pin, digitalio.DigitalInOut):
            pin[0].direction = digitalio.Direction.INPUT
        else:
            if len(pin):
                pin[0].deinit()
                pin[0] = digitalio.DigitalInOut(pinNumber)
                pin[0].direction = digitalio.Direction.INPUT
            else:
                pin.append(digitalio.DigitalInOut(pinNumber))
                pin[0].direction = digitalio.Direction.INPUT
    elif type == "analog_read":
        if len(pin) == 0 or not isinstance(pin, analogio.AnalogIn):
            if len(pin):
                pin[0].deinit()
                pin[0] = analogio.AnalogIn(pinNumber)
            else:
                pin.append(analogio.AnalogIn(pinNumber))
    return pin

def digital_write(pin, pinNumber, state):
    pin = configure_pin(pin, pinNumber, "digital_write")
    pin[0].value = state

def digital_read(pin, pinNumber):
    pin = configure_pin(pin, pinNumber, "digital_read")
    return pin[0].value

def on_pressed_a(button):
    digital_write(pin1, board.P1, True)
    print('Tapis en marche...')

def on_pressed_b(button):
    digital_write(pin1, board.P1, False)
    print('Tapis arrêté')

pin1 = []
pin19 = []
pin7 = []
button_a.on_button_pressed(on_pressed_a)
button_b.on_button_pressed(on_pressed_b)

display_clear()
print('TP n°7 MSPC')
print('Test bouteille tombée')
print('Appui sur A avancer Tapis')
print('Appui sur B arrêter tapis')
print('Capteur haut P7')
print('Capteur bas P19')
print('Relais tapis sur P1')
digital_write(pin1, board.P1, False)

while True:
    if not digital_read(pin19, board.P19):
        time.sleep((600)*0.001)
        if not digital_read(pin7, board.P7):
            print('Bouteille ok droite')
        else:
            if not digital_read(pin19, board.P19):
                print('Bouteille tombée!')
